defmodule AoC2021.Test11 do
  use ExUnit.Case, async: true

  alias AoC2021.Day11

  # as opposed to day 9 (bassins), I decided to store the grid as a 1d map with {x, y} coords as keys
  @data %{
    {0, 0} => 5, {1, 0} => 4, {2, 0} => 8, {3, 0} => 3, {4, 0} => 1, {5, 0} => 4, {6, 0} => 3, {7, 0} => 2, {8, 0} => 2, {9, 0} => 3,
    {0, 1} => 2, {1, 1} => 7, {2, 1} => 4, {3, 1} => 5, {4, 1} => 8, {5, 1} => 5, {6, 1} => 4, {7, 1} => 7, {8, 1} => 1, {9, 1} => 1,
    {0, 2} => 5, {1, 2} => 2, {2, 2} => 6, {3, 2} => 4, {4, 2} => 5, {5, 2} => 5, {6, 2} => 6, {7, 2} => 1, {8, 2} => 7, {9, 2} => 3,
    {0, 3} => 6, {1, 3} => 1, {2, 3} => 4, {3, 3} => 1, {4, 3} => 3, {5, 3} => 3, {6, 3} => 6, {7, 3} => 1, {8, 3} => 4, {9, 3} => 6,
    {0, 4} => 6, {1, 4} => 3, {2, 4} => 5, {3, 4} => 7, {4, 4} => 3, {5, 4} => 8, {6, 4} => 5, {7, 4} => 4, {8, 4} => 7, {9, 4} => 8,
    {0, 5} => 4, {1, 5} => 1, {2, 5} => 6, {3, 5} => 7, {4, 5} => 5, {5, 5} => 2, {6, 5} => 4, {7, 5} => 6, {8, 5} => 4, {9, 5} => 5,
    {0, 6} => 2, {1, 6} => 1, {2, 6} => 7, {3, 6} => 6, {4, 6} => 8, {5, 6} => 4, {6, 6} => 1, {7, 6} => 7, {8, 6} => 2, {9, 6} => 1,
    {0, 7} => 6, {1, 7} => 8, {2, 7} => 8, {3, 7} => 2, {4, 7} => 8, {5, 7} => 8, {6, 7} => 1, {7, 7} => 1, {8, 7} => 3, {9, 7} => 4,
    {0, 8} => 4, {1, 8} => 8, {2, 8} => 4, {3, 8} => 6, {4, 8} => 8, {5, 8} => 4, {6, 8} => 8, {7, 8} => 5, {8, 8} => 5, {9, 8} => 4,
    {0, 9} => 5, {1, 9} => 2, {2, 9} => 8, {3, 9} => 3, {4, 9} => 7, {5, 9} => 5, {6, 9} => 1, {7, 9} => 5, {8, 9} => 2, {9, 9} => 6
  }

  test "setup" do
    assert Day11.setup("#{__DIR__}/data/test.txt") === @data
  end

  test "part1" do
    assert Day11.part1(@data) === 1_656
  end

  test "part2" do
    assert Day11.part2(@data) === 195
  end
end
